SystemOrganization addCategory: #'Seaside-JSON-Core'!

WADocument subclass: #WAJsonDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Core'!

!WAJsonDocument methodsFor: 'writing' stamp: 'pmm 8/24/2011 12:08'!
closeArray
	stream nextPut: $]! !

!WAJsonDocument methodsFor: 'writing' stamp: 'pmm 8/24/2011 12:08'!
closeObject
	stream nextPut: $}! !

!WAJsonDocument methodsFor: 'writing' stamp: 'pmm 8/24/2011 14:04'!
openArray
	stream nextPut: $[! !

!WAJsonDocument methodsFor: 'writing' stamp: 'pmm 8/24/2011 14:04'!
openObject
	stream nextPut: ${! !

WACanvas subclass: #WAJsonCanvas
	instanceVariableNames: 'first'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Core'!

!WAJsonCanvas methodsFor: 'public' stamp: 'pmm 8/24/2011 13:57'!
array: aBlock
	^ (self brush: WAJsonArrayBrush new) with: aBlock! !

!WAJsonCanvas methodsFor: 'public' stamp: 'pmm 9/25/2011 19:13'!
callback: aNiladicValuable 
	aNiladicValuable argumentCount > 0 ifTrue: [ GRInvalidArgumentCount signal: 'JSON expects a niladic callback.' ].
	self render: (self actionUrl copy addField: (self callbacks store: (WAJsonActionCallback on: aNiladicValuable)))! !

!WAJsonCanvas methodsFor: 'initialization' stamp: 'pmm 8/24/2011 15:05'!
initializeWithContext: aRenderContext
	super initializeWithContext: aRenderContext.
	first := true! !

!WAJsonCanvas methodsFor: 'public' stamp: 'pmm 8/24/2011 15:15'!
key: aKeyString value: aValueObject
	^ (self brush: (WAJsonKeyValueBrush key: aKeyString)) with: aValueObject! !

!WAJsonCanvas methodsFor: 'private' stamp: 'pmm 8/24/2011 15:06'!
nest: aBlock
	| oldFirst |
	oldFirst := first.
	first := true.
	super nest: aBlock.
	first := false! !

!WAJsonCanvas methodsFor: 'public' stamp: 'pmm 8/24/2011 13:58'!
object: aBlock
	^ (self brush: WAJsonObjectBrush new) with: aBlock! !

!WAJsonCanvas methodsFor: 'public' stamp: 'pmm 8/24/2011 14:38'!
render: anObject
	self flush.
	anObject renderJsonOn: self! !

!WAJsonCanvas methodsFor: 'public' stamp: 'pmm 8/24/2011 14:25'!
value: aBlock
	^ (self brush: WAJsonValueBrush new) with: aBlock! !

!WAJsonCanvas methodsFor: 'private' stamp: 'pmm 8/24/2011 15:07'!
writeIfNotFirst: aString
	first ifFalse: [
		self document nextPutAll: aString ]! !

!WAUrl methodsFor: '*seaside-json-core' stamp: 'pmm 9/24/2011 11:14'!
jsonOn: aStream
	self javascriptOn: aStream ! !

!BlockClosure methodsFor: '*seaside-json-core' stamp: 'pmm 8/24/2011 14:37'!
renderJsonOn: aRenderer
	self numArgs = 0
		ifTrue: [ self value ]
		ifFalse: [ self value: aRenderer ]! !

WABrush subclass: #WAJsonBrush
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Core'!

WAJsonBrush subclass: #WAJsonArrayBrush
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Core'!

!WAJsonArrayBrush methodsFor: 'private' stamp: 'pmm 8/24/2011 12:09'!
closeBrush
	self document closeArray! !

!WAJsonArrayBrush methodsFor: 'private' stamp: 'pmm 8/24/2011 14:05'!
openBrush
	self document openArray! !

!WAJsonBrush methodsFor: 'private' stamp: 'pmm 8/24/2011 12:08'!
closeBrush
	self subclassResponsibility! !

!WAJsonBrush methodsFor: 'accessing' stamp: 'pmm 8/24/2011 14:06'!
document
	^ canvas document! !

!WAJsonBrush methodsFor: 'private' stamp: 'pmm 8/24/2011 14:00'!
openBrush
	self subclassResponsibility! !

!WAJsonBrush methodsFor: 'public' stamp: 'pmm 8/24/2011 14:07'!
with: anObject

	self openBrush.
	super with: [
		canvas render: anObject ].
	self closeBrush! !

WAJsonBrush subclass: #WAJsonElementBrush
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Core'!

!WAJsonElementBrush methodsFor: 'private' stamp: 'pmm 8/24/2011 15:11'!
closeBrush! !

!WAJsonElementBrush methodsFor: 'private' stamp: 'pmm 8/24/2011 15:11'!
openBrush
	canvas writeIfNotFirst: ', '! !

WAJsonElementBrush subclass: #WAJsonKeyValueBrush
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Core'!

!WAJsonKeyValueBrush class methodsFor: 'instance creation' stamp: 'pmm 8/24/2011 15:10'!
key: aString
	^ self basicNew initializeWithKey: aString! !

!WAJsonKeyValueBrush methodsFor: 'initialization' stamp: 'pmm 8/24/2011 15:10'!
initializeWithKey: aString
	self initialize.
	key := aString! !

!WAJsonKeyValueBrush methodsFor: 'private' stamp: 'pmm 8/24/2011 15:18'!
openBrush
	super openBrush.
	key renderJsonOn: canvas.
	self document stream nextPutAll: ': '! !

WAJsonElementBrush subclass: #WAJsonValueBrush
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Core'!

WAJsonBrush subclass: #WAJsonObjectBrush
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Core'!

!WAJsonObjectBrush methodsFor: 'private' stamp: 'pmm 8/24/2011 12:10'!
closeBrush
	self document closeObject! !

!WAJsonObjectBrush methodsFor: 'private' stamp: 'pmm 8/24/2011 14:05'!
openBrush
	self document openObject! !

WAActionCallback subclass: #WAJsonActionCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Core'!

!WAJsonActionCallback methodsFor: 'testing' stamp: 'pmm 9/25/2011 19:13'!
isEnabledFor: aRequestContext
	"enabled even for XmlHttpRequests"
	^ true! !

!Object methodsFor: '*seaside-json-core' stamp: 'pmm 8/24/2011 14:37'!
renderJsonOn: aRenderer
	self jsonOn: aRenderer document stream! !
